routes/web.php
<?php

use App\Http\Livewire\Posts;
use App\Http\Livewire\HomeComponent;
use Illuminate\Support\Facades\Route;
use App\Http\Livewire\AboutUsComponent;
use App\Http\Livewire\ContactUsComponent;
use App\Http\Livewire\ReturnPolicyComponent;
use App\Http\Livewire\PrivacyPolicyComponent;
use App\Http\Livewire\UserDashboardComponent;
use App\Http\Livewire\TermsConditionsComponent;
use App\Http\Livewire\Category\CategoryComponent;
use App\Http\Controllers\Admin\CategoryController;
use App\Http\Livewire\Admin\AdminDashboardComponent;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



Route::get('/', HomeComponent::class);

Route::get('/about-us', AboutUsComponent::class);

Route::get('/privacy-policy', PrivacyPolicyComponent::class);

Route::get('/terms-conditions', TermsConditionsComponent::class);

Route::get('/return-policy', ReturnPolicyComponent::class);

Route::get('/contact-us', ContactUsComponent::class);





// Dashboard particular users or clientes
Route::middleware(['auth:sanctum', 'verified'])->group(function () {
    Route::get('/dashboard', UserDashboardComponent::class)->name('user.dashboard');
});

// Dashboard particular admin
Route::middleware(['auth:sanctum', 'verified'])->group(function () {
    Route::get('/admin/dashboard', AdminDashboardComponent::class)->name('admin.dashboard');

    Route::resource('admin/categories', CategoryController::class);
});

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Category extends Model
{
    use HasFactory,SoftDeletes;
    protected $guarded = [
        'id',
    ];

    public function children()
    {
        return $this->hasMany(self::class, 'parent_id');
    }

    public function parent()
    {
        return $this->belongsTo(self::class, 'parent_id');
    }
}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use Exception;
use App\Models\Category;
use App\Services\CategoryService;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Redirect;
use App\Http\Requests\CategoryCreateRequest;

class CategoryController extends Controller
{
    protected $categoryService;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct(CategoryService $categoryService)
    {
        $this->categoryService = $categoryService;
        $this->middleware('auth');
    }


    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = $this->categoryService->get();
        return view('admin.category.index', compact('categories'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        // $categories = $this->categoryService->get();
        $categories = $this->categoryService->get();

        return view('admin.category.create', compact('categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CategoryCreateRequest $request)
    {
        try {
            $this->categoryService->createCategory($request);
            toastr()->success('Category added');
            return redirect()->route('categories.index');
        } catch (Exception $e) {
            return $result = [
                'status' => 500,
                'error' => $e->getMessage()
            ];
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        return $this->categoryService->getById($id);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        dd($id . 'edit');
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update($request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Category $category)
    {

        $this->categoryService->deleteCategory($category);

        return Redirect::route('categories.index')
            ->with('flash_notification.message', 'Category has been deleted.')
            ->with('flash_notification.level', 'success');
    }
}

resources/views/admin/category/create.blade.php
@extends('layouts.admin')
@section('content')



    <div class="content-page">
        <div class="content">

            <!-- Start Content-->
            <div class="container-fluid">

                <!-- start page title -->
                <div class="row">
                    <div class="col-12">
                        <div class="page-title-box">
                            <div class="page-title-right">
                                <ol class="breadcrumb m-0">
                                    <li class="breadcrumb-item"><a href="javascript: void(0);">Upvex</a></li>
                                    <li class="breadcrumb-item"><a href="javascript: void(0);">Forms</a></li>
                                    <li class="breadcrumb-item active">Form Validation</li>
                                </ol>
                            </div>
                            <h4 class="page-title">Category Information</h4>
                        </div>
                    </div>
                </div>
                <!-- end page title -->



                <div class="row">
                    <div class="col-lg">
                        <div class="card-box">
                            <h4 class="header-title">Category Information</h4>
                            <hr>

                            <form class="parsley-examples" action="{{ route('categories.store') }}" method="POST" enctype="multipart/form-data">
                                @csrf
                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Name</label>
                                    <div class="col-md-9">
                                        <input type="text" placeholder="Name" name="name" id="name"
                                            value="{{ old('name') }}" class="form-control" required>
                                        @error('name') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Parent Category</label>
                                    <div class="col-md-9">
                                        <select class="select2 form-control aiz-selectpicker" name="parent_id"
                                            data-toggle="select2" data-placeholder="Choose ..." data-live-search="true"
                                            required>
                                            <option value="">Choose Parent</option>
                                            <option value="0" {{ old('parent_id') == 0 ? 'selected' : '' }}>No Parent
                                            </option>

                                            <!-- Displaying the current category -->
                                            @foreach ($categories->where('parent_id', 0) as $category)
                                                <option value="{{ $category->id }}"
                                                    {{ old('parent_id') == $category->id ? 'selected' : '' }}>
                                                    {{ $category->name }}</option>

                                                <!-- If category has children -->
                                                @if (count($category->children) > 0)
                                                    @foreach ($category->children as $sub)
                                                        <option value="{{ $sub->id }}">-- {{ $sub->name }}</option>
                                                        @include('admin.subcategories.subcategory', ['category' => $sub])
                                                    @endforeach
                                                @endif
                                            @endforeach
                                        </select>
                                        @error('parent_id') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">
                                        Ordering Number
                                    </label>
                                    <div class="col-md-9">
                                        <input type="number" class="form-control" name="order_level"
                                            value="{{ old('order_level') }}" placeholder="Order Level">
                                        <p> @error('order_level') <span
                                                class="text-danger">{{ $message }}</span>@enderror</p>
                                        <small>Lower number has high priority</small>
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">
                                        Banner (200x200)
                                    </label>
                                    <div class="col-md-9">
                                        <input type="file" class="form-control" name="banner" id="banner" placeholder="Order Level">
                                        @error('banner') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label" for="signinSrEmail">icon
                                        <small>(32x32)</small></label>
                                    <div class="col-md-9">
                                        <input type="file" class="form-control" name="icon" placeholder="Order Level">
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Meta Title</label>
                                    <div class="col-md-9">
                                        <input type="text" class="form-control" name="meta_title"
                                            value="{{ old('meta_title') }}" placeholder="Meta Title">
                                        @error('meta_title') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Meta description</label>
                                    <div class="col-md-9">
                                        <textarea name="meta_description" id="meta_description" rows="5"
                                            class="form-control">{{ old('meta_description') }}</textarea>
                                        @error('meta_description') <span
                                            class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>


                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Slug</label>
                                    <div class="col-md-9">
                                        <input type="text" placeholder="Slug" name="slug" id="slug"
                                            value="{{ old('slug') }}" class="form-control">
                                        @error('slug') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>

                                <div class="form-group mb-0 text-right">
                                    <button type="submit" class="btn btn-danger waves-effect waves-light"
                                    data-overlayColor="#38414a">Save</button>
                                </div>
                            </form>
                        </div> <!-- end card-box -->

                    </div> <!-- end col -->
                    <!-- end col -->

                </div>
                <!-- end row -->

            </div> <!-- container -->

        </div> <!-- content -->

    </div>


@endsection

resources/views/admin/category/edit.blade.php
@extends('layouts.admin')
@section('content')



    <div class="content-page">
        <div class="content">

            <!-- Start Content-->
            <div class="container-fluid">

                <!-- start page title -->
                <div class="row">
                    <div class="col-12">
                        <div class="page-title-box">
                            <div class="page-title-right">
                                <ol class="breadcrumb m-0">
                                    <li class="breadcrumb-item"><a href="javascript: void(0);">Upvex</a></li>
                                    <li class="breadcrumb-item"><a href="javascript: void(0);">Forms</a></li>
                                    <li class="breadcrumb-item active">Form Validation</li>
                                </ol>
                            </div>
                            <h4 class="page-title">Category Information</h4>
                        </div>
                    </div>
                </div>
                <!-- end page title -->



                <div class="row">
                    <div class="col-lg">
                        <div class="card-box">
                            <h4 class="header-title">Category Information</h4>
                            <hr>

                            <form class="parsley-examples" action="{{ route('categories.update',['category'=>$category->id]) }}" method="post" enctype="multipart/form-data">
                                @csrf
                                @method('PUT')
                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Name</label>
                                    <div class="col-md-9">
                                        <input type="text" placeholder="Name" name="name" id="name"
                                            value="{{ $category->name }}" class="form-control" required>
                                        @error('name') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Parent Category</label>
                                    <div class="col-md-9">
                                        <select class="select2 form-control aiz-selectpicker" name="parent_id"
                                            data-toggle="select2" data-placeholder="Choose ..." data-live-search="true"
                                            required>
                                            <option value="">Choose Parent</option>
                                            <option value="0" {{ old('parent_id') == 0 ? 'selected' : '' }}>No Parent
                                            </option>

                                            <!-- Displaying the current category -->
                                            @foreach ($categories->where('parent_id', 0) as $category)
                                                <option value="{{ $category->id }}"
                                                    {{ $category->id == $category->id ? 'selected' : '' }}>
                                                    {{ $category->name }}</option>

                                                <!-- If category has children -->
                                                @if (count($category->children) > 0)
                                                    @foreach ($category->children as $sub)
                                                        <option value="{{ $sub->id }}">-- {{ $sub->name }}</option>
                                                        @include('admin.subcategories.subcategory', ['category' => $sub])
                                                    @endforeach
                                                @endif
                                            @endforeach
                                        </select>
                                        @error('parent_id') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">
                                        Ordering Number
                                    </label>
                                    <div class="col-md-9">
                                        <input type="number" class="form-control" name="order_level"
                                            value="{{ $category->order_level }}" placeholder="Order Level">
                                        <p> @error('order_level') <span
                                                class="text-danger">{{ $message }}</span>@enderror</p>
                                        <small>Lower number has high priority</small>
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">
                                        Banner (200x200)
                                    </label>

                                    <div class="col-md-9">
                                        <input type="file" class="form-control" name="banner" id="banner" placeholder="Order Level" accept="image/*" onchange="bannerFile(event)">
                                        @error('banner') <span class="text-danger">{{ $message }}</span>@enderror
                                        <img src="{{ asset(CATEGORY_BANNER_IMAGE_URL . '/' . $category->id . '/' . $category->banner) }}" id="banner_prev" width="40px"/>
                                    </div>

                                </div>


                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label" for="signinSrEmail">icon
                                        <small>(32x32)</small></label>
                                    <div class="col-md-9">
                                        <input type="file" class="form-control" name="icon" accept="image/*" onchange="iconFile(event)">
                                        <img src="{{ asset(CATEGORY_ICON_IMAGE_URL . '/' . $category->id . '/' . $category->icon) }}" id="icon_prev" width="40px"/>
                                    </div>
                                </div>


                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Meta Title</label>
                                    <div class="col-md-9">
                                        <input type="text" class="form-control" name="meta_title"
                                            value="{{ $category->meta_title }}" placeholder="Meta Title">
                                        @error('meta_title') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Meta description</label>
                                    <div class="col-md-9">
                                        <textarea name="meta_description" id="meta_description" rows="5"
                                            class="form-control">{{ $category->meta_description }}</textarea>
                                        @error('meta_description') <span
                                            class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>


                                <div class="form-group row">
                                    <label class="col-md-3 col-form-label">Slug</label>
                                    <div class="col-md-9">
                                        <input type="text" placeholder="Slug" name="slug" id="slug"
                                            value="{{ $category->slug }}" class="form-control">
                                        @error('slug') <span class="text-danger">{{ $message }}</span>@enderror
                                    </div>
                                </div>

                                <div class="form-group mb-0 text-right">
                                    <button type="submit" class="btn btn-danger waves-effect waves-light"
                                    data-overlayColor="#38414a">Save</button>
                                </div>
                            </form>
                        </div> <!-- end card-box -->

                    </div> <!-- end col -->
                    <!-- end col -->

                </div>
                <!-- end row -->

            </div> <!-- container -->

        </div> <!-- content -->

    </div>



    <script>
        var bannerFile = function(event) {
          var output = document.getElementById('banner_prev');
          output.src = URL.createObjectURL(event.target.files[0]);
          output.onload = function() {
            URL.revokeObjectURL(output.src) // free memory
          }
        };

        var iconFile = function(event) {
          var output = document.getElementById('icon_prev');
          output.src = URL.createObjectURL(event.target.files[0]);
          output.onload = function() {
            URL.revokeObjectURL(output.src) // free memory
          }
        };
      </script>

@endsection

resources/views/admin/category/index.blade.php
@extends('layouts.admin')
@section('content')

    <div class="content-page">
        <div class="content">

            <!-- Start Content-->
            <div class="container-fluid">

                <!-- start page title -->
                <div class="row">
                    <div class="col-12">
                        <div class="page-title-box">
                            <div class="page-title-right">
                                <ol class="breadcrumb m-0">
                                    <li class="breadcrumb-item"><a href="javascript: void(0);">Upvex</a></li>
                                    <li class="breadcrumb-item"><a href="javascript: void(0);">Forms</a></li>
                                    <li class="breadcrumb-item active">Form Validation</li>
                                </ol>
                            </div>
                            <h4 class="page-title">Category Information</h4>
                        </div>
                    </div>
                </div>
                <!-- end page title -->

                <div class="row">
                    <div class="col-12">
                        <div class="card-box">
                            <div class="row">
                                <div class="col-lg-8">
                                    <form class="form-inline">
                                        <div class="form-group">
                                            <label for="inputPassword2" class="sr-only">Search</label>
                                            <input type="search" class="form-control" name="keyword"
                                                placeholder="Search...">
                                        </div>
                                        <div class="form-group mx-sm-3">
                                            <label for="status-select" class="mr-2">Sort By</label>
                                            <select class="custom-select" id="status-select">
                                                <option selected="">All</option>
                                                <option value="1">Name</option>
                                                <option value="2">Job Success</option>
                                                <option value="3">Total Earned</option>
                                                <option value="4">Hours Worked</option>
                                            </select>
                                        </div>
                                    </form>
                                </div>
                                <div class="col-lg-4">
                                    <div class="text-lg-right mt-3 mt-lg-0">
                                        <a href="{{ route('categories.create') }}" class="btn btn-danger waves-effect waves-light"
                                             data-overlayColor="#38414a"><i
                                                class="mdi mdi-plus-circle mr-1"></i> Add New Category</a>
                                    </div>
                                </div><!-- end col-->
                            </div> <!-- end row -->
                        </div> <!-- end card-box -->
                    </div><!-- end col-->
                </div>
                <!-- end row -->





                <div class="row">
                    <div class="col">
                        <div class="card-box">

                            <div class="table-responsive">
                                <table class="table table-sm mb-0">
                                    <thead>
                                        <tr>
                                            <th>#</th>
                                            <th>Name</th>
                                            <th>Parent Category</th>
                                            <th>Order Level</th>
                                            <th>Level</th>
                                            <th>Banner</th>
                                            <th>Icon</th>
                                            <th>Featured</th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @forelse ($categories as $category)
                                            <tr>
                                                <th scope="row">{{ $loop->iteration }}</th>
                                                <td>{{ $category->name }}</td>

                                                @if ($category->parent_id != 0)
                                                <td>{{ $category->parent ->name}}</td>
                                                @else
                                                <td>-</td>
                                                @endif

                                                <td>{{ $category->order_level }}</td>
                                                <td>{{ $category->level }}</td>



                                                <td><img src="{{ asset(CATEGORY_BANNER_IMAGE_URL . '/' . $category->id . '/' . $category->banner) }}" alt=""  class="rounded-circle avatar-xs"></td>

                                                <td><img src="{{ asset(CATEGORY_ICON_IMAGE_URL . '/' . $category->id . '/' . $category->icon) }}" alt="" class="rounded-circle avatar-xs"></td>


                                                <td>

                                                    <a href="{{ route('categories.edit',['category'=>$category->id]) }}"><i class="fa fa-edit btn btn-success" aria-hidden="true"></i></a>

                                                    <form action="{{ route('categories.destroy',['category'=>$category->id]) }}" method="POST">
                                                        <input type="hidden" name="_method" value="DELETE">
                                                        <input type="hidden" name="_token" value="{{ csrf_token() }}">
                                                        <button class="btn btn-danger m-1"><i class="fa fa-trash" aria-hidden="true"></i></button>
                                                    </form>



                                                </td>
                                            </tr>
                                            @empty

                                        @endforelse

                                    </tbody>
                                </table>
                            </div> <!-- end table-responsive-->

                            {{-- @include('pagination.default', ['paginator' => $categories]) --}}


                        </div> <!-- end card-box -->
                    </div> <!-- end col -->

                    <!-- end row -->

                </div> <!-- container -->

            </div> <!-- content -->
        </div>

    @endsection